﻿Type=Service
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Public sql As SQL
	Public rp As RuntimePermissions
End Sub

Sub Service_Create
	File.Delete(DBUtils.GetDBFolder, "1.db")
	sql.Initialize(DBUtils.GetDBFolder, "1.db", True)
	DBUtils.DropTable(sql, "Students")
	DBUtils.DropTable(sql, "Grades")
	DBUtils.DropTable(sql, "DBVersion")
	DBUtils.CreateTable(sql, "Grades", CreateMap("Id": DBUtils.DB_TEXT, "Test": DBUtils.DB_TEXT, "Grade": DBUtils.DB_INTEGER), "") 'no primary key assigned
	'Create the students table which holds data about each student.
	DBUtils.CreateTable(sql, "Students",  _
		CreateMap("Id": DBUtils.DB_TEXT, "First Name": DBUtils.DB_TEXT, "Last Name": DBUtils.DB_TEXT,"Birthday": DBUtils.DB_INTEGER) _
		, "Id")
	FillStudentsTable
	FillGradesTable
End Sub

Sub FillStudentsTable
	Dim ListOfMaps As List
	ListOfMaps.Initialize
	Dim id As Int
	For i = 1 To 40
		Dim m As Map
		m.Initialize
		id = Rnd(id + 1, id + 10000)
		m.Put("Id", NumberFormat2(id, 6, 0, 0, False))
		m.Put("First Name", "John")
		m.Put("Last Name", "Smith" & i)
		m.Put("Birthday", DateTime.Add(DateTime.Now, Rnd(-100, 0), Rnd(-12, 0), Rnd(-30, 0)))
		ListOfMaps.Add(m)
	Next
	DBUtils.InsertMaps(sql, "Students", ListOfMaps)
End Sub

Sub FillGradesTable
	'Building this table is a little bit more complicated.
	'We will create 20 tests and for each test we will give each student a grade.
	'We need to first get the list of possible student IDs.
	Dim Table As List
	Table = DBUtils.ExecuteMemoryTable(sql, "SELECT Id FROM Students", Null, 0)
	'Table is a list of arrays. Each array holds a single item.
	Dim Cols() As String
	Dim ListOfMaps As List
	ListOfMaps.Initialize
	For test = 1 To 20
		For student = 0 To Table.Size - 1
			Dim m As Map
			m.Initialize
			Cols = Table.Get(student)
			ListOfMaps.Add(CreateMap("Id": Cols(0), "Test": "Test #" & test, "Grade": Rnd(0, 101)))
		Next
	Next
	DBUtils.InsertMaps(sql, "Grades", ListOfMaps)
End Sub



Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Service_Destroy

End Sub
